'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _progress = require('./utils/progress');

var _progress2 = _interopRequireDefault(_progress);

var _log = require('./utils/log');

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _bluebird2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _bluebird2.default.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var globAsync = (0, _bluebird.promisify)(_glob2.default);

_bluebird2.default.seriesMap = function (arr, mapFn) {
  var p = arr.map(mapFn);
  return _bluebird2.default.reduce(p, function (values, promise) {
    return promise().then(function (result) {
      return [].concat(_toConsumableArray(values), [result]);
    });
  }, []);
};

var createRawlys = function createRawlys(paths) {
  return _bluebird2.default.resolve(paths.map(function (path) {
    return new _index2.default(path);
  }));
};
var extractPreview = function extractPreview(rawlys, _ref) {
  var size = _ref.size;
  var ending = _ref.ending;
  return _bluebird2.default.seriesMap(rawlys, function (rawly) {
    return function () {
      return rawly.extractPreview(size, ending);
    };
  });
};

exports.default = function () {
  var _ref2 = _asyncToGenerator(_regenerator2.default.mark(function _callee(program) {
    var _program$args, globPattern, paths, rawlys, previews;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _program$args = _slicedToArray(program.args, 1);
            globPattern = _program$args[0];
            _context.next = 4;
            return globAsync(globPattern);

          case 4:
            paths = _context.sent;


            (0, _log.logFilesFound)(paths);
            _progress2.default.init(paths.length);
            _progress2.default.tick(0);

            _context.next = 10;
            return createRawlys(paths);

          case 10:
            rawlys = _context.sent;
            _context.next = 13;
            return extractPreview(rawlys, program);

          case 13:
            previews = _context.sent;
            return _context.abrupt('return', previews);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function extract(_x) {
    return _ref2.apply(this, arguments);
  }

  return extract;
}();