'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.logError = exports.logSuccess = exports.logFilesFound = undefined;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var logFilesFound = exports.logFilesFound = function logFilesFound(paths) {
  return console.log(_chalk2.default.blue('\n    > Found ' + paths.length + ' images and starts extracting previews...\n  '));
};

var logSuccess = exports.logSuccess = function logSuccess(extracted, startTime) {
  var performed = extracted.filter(function (bool) {
    return bool;
  });
  var skipped = extracted.filter(function (bool) {
    return !bool;
  });

  var diff = (0, _moment2.default)().diff(startTime, 'seconds', true);

  console.log(_chalk2.default.green('\n    > ' + performed.length + ' successfully extracted previews.\n    > ' + skipped.length + ' skipped files because they already had a preview.\n    > Completed in ' + diff + ' seconds.\n  '));
};

var logError = exports.logError = function logError(err) {
  console.log(_chalk2.default.red(err.message));
  console.log(_chalk2.default.dim(err));
};