'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extract;

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _crossSpawn = require('cross-spawn');

var _crossSpawn2 = _interopRequireDefault(_crossSpawn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import { join } from 'path';

function extract(fullPath) {
  return new _bluebird2.default(function (resolve, reject) {
    var exif = (0, _crossSpawn2.default)('exiftool', ['-b', '-previewimage', fullPath], { stdio: 'pipe' });
    var buffers = [];

    exif.stdout.on('data', function (data) {
      return buffers.push(data);
    });
    exif.stderr.on('data', function (err) {
      return reject(err.toString());
    });

    exif.on('close', function (code) {
      if (code !== 0) {
        var error = new Error('exiftool ended with code ' + code);
        return reject(error);
      }

      var buffer = Buffer.concat(buffers);
      return resolve(buffer);
    });
  });
}